% AI-LAB-II / Exercise 4

:- dynamic([breeze/2,
	no_breeze/2,
	stench/2,
	no_stench/2,
	glitter/2,
	no_glitter/2,
	save/2]).

percept(B,S,G,X,Y) :-
	pos_ok(X,Y),
	asserta(save(X,Y)),
	breezy(B,X,Y),
	stinky(S,X,Y),
	glittery(G,X,Y).

pos_ok(X,Y) :-
	integer(X),
	integer(Y),
	X > 0,
	X < 5,
	Y > 0,
	Y < 5.

breezy(B,X,Y) :-
	(
	    B = true  ->
	    (
		asserta(breeze(X,Y)),
		(
		    no_breeze(X,Y) -> retract(no_breeze(X,Y));
		    true
		)
	    );
	    (
		asserta(no_breeze(X,Y)),
		(
		    breeze(X,Y) -> retract(breeze(X,Y));
		    true
		)
	    )
	).

stinky(S,X,Y) :-
	(
	    S = true  ->
	    (
		asserta(stench(X,Y)),
		(
		    no_stench(X,Y) -> retract(no_stench(X,Y));
		    true
		)
	    );
	    (
		asserta(no_stench(X,Y)),
		(
		    stench(X,Y) -> retract(stench(X,Y));
		    true
		)
	    )
	).

glittery(G,X,Y) :-
	(
	    G = true  ->
	    (
		asserta(glitter(X,Y)),
		(
		    no_glitter(X,Y) -> retract(no_glitter(X,Y));
		    true
		)
	    );
	    (
		asserta(no_glitter(X,Y)),
		(
		    glitter(X,Y) -> retract(glitter(X,Y));
		    true
		)
	    )
	).

pit(X,Y) :-
	XP is X + 1,
	XM is X - 1,
	YP is Y + 1,
	YM is Y - 1,
	(
	    breeze(XP,Y);
	    breeze(XM,Y);
	    breeze(X,YP);
	    breeze(X,YM)
	),
	(
	    \+no_breeze(XP,Y),
	    \+no_breeze(XM,Y),
	    \+no_breeze(X,YP),
	    \+no_breeze(X,YM)
	).

wumpus(X,Y) :-
	XP is X + 1,
	XM is X - 1,
	YP is Y + 1,
	YM is Y - 1,
	(
	    stench(XP,Y);
	    stench(XM,Y);
	    stench(X,YP);
	    stench(X,YM)
	),
	(
	    \+no_stench(XP,Y),
	    \+no_stench(XM,Y),
	    \+no_stench(X,YP),
	    \+no_stench(X,YM)
	).

ok(X,Y) :- 
	save(X,Y);
	(
	    \+pit(X,Y),
	    \+wumpus(X,Y)
	).

gold(X,Y) :- glitter(X,Y).

action(right,X,Y) :-
	pos_ok(X,Y),
	XP is X + 1,
	pos_ok(XP,Y),
	ok(XP,Y).

action(left,X,Y) :-
	pos_ok(X,Y),
	XP is X - 1,
	pos_ok(XP,Y),
	ok(XP,Y).

action(up,X,Y) :-
	pos_ok(X,Y),
	YP is Y + 1,
	pos_ok(X,YP),
	ok(X,YP).

action(down,X,Y) :-
	pos_ok(X,Y),
	YP is Y - 1,
	pos_ok(X,YP),
	ok(X,YP).

action(shoot,X,Y) :-
	pos_ok(X,Y),
	stench(X,Y).

action(grab,X,Y) :-
	pos_ok(X,Y),
	gold(X,Y).
