// game_simple.cc: Simple game test agent.
// 
// Copyright (C) 2004 Frank Langbein <frank@langbein.org>
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
// 
// $Id: main.cc,v 2.7 2003/09/01 12:30:26 scmfcl Exp $

#include "config.h"
#include "stdio.h"

RCSID (game_simple, "$Id$");

int main (int argc, char **argv)
{
  srand (time (NULL));

  // Identify myself
  cout << "GAME" << endl;

  // World info
  string in;
  cin >> in;
  long N;
  char id;
  sscanf (in.c_str (), "SCHECKERS:%ld:%c", &N, &id);
  
  long M = (N * N + 1) >> 1;
  short board[M];

  // Do nothing forever...
  while (true) {

    cin >> in;
    if (in == "KILL") {
      cout << "DYING\n";
      break;
    }

    long p = 0;
    while (p < M) {
      char c = in[p];
      if (c == id) {
	board[p] = 1;
      } else if (c == '_') {
	board[p] = 0;
      }  else {
	board[p] = -1;
      }
      ++p;
    }

    long from = 0, toc = 0, tor = 0, to = 0, dr = 0, dc = 0;

    do {
      do {
	from = static_cast<long> (static_cast<double> (M) * RAND);
      } while (board[from] != 1);
      long fromr = (from * 2) / N;
      long fromc = (from * 2) % N;
      if ((N%2) == 0)
	fromc += (fromr % 2);
      do {
	switch (static_cast<long> (4.0 * RAND)) {
	case 0:
	  dr = +1;
	  dc = +1;
	  break;
	case 1:
	  dr = +1;
	  dc = -1;
	  break;
	case 2:
	  dr = -1;
	  dc = +1;
	  break;
	case 3:
	  dr = -1;
	  dc = -1;
	  break;
	}
	tor = fromr + dr;
	toc = fromc + dc;
      } while (tor < 0 || tor >= N || toc < 0 || toc >= N);

      to = toc / 2;
      long l = 0;
      while (l < tor) {
	to += (N/2);
	if ((N%2) == 1 && (l%2) == 0) 
	  ++to;
	++l;
      } 
      // cerr << "FROM: " << fromr << " : " << fromc << " : " << from << " = " << board[from] << endl;
      // cerr << "TO:   " << tor << " : " << toc << " : " << to << " = " << board[to] << endl;
      if (board[to] == -1) {
	long ttor = tor + dr;
	long ttoc = toc + dc;
	if (ttor >= 0 && ttor < N && ttoc >= 0 && ttoc < N) {
	  // cerr << "JUMP\n";
	  tor = ttor;
	  toc = ttoc;
	  to = toc / 2;
	  long l = 0;
	  while (l < tor) {
	    to += (N/2);
	    if ((N%2) == 1 && (l%2) == 0) 
	      ++to;
	    ++l;
	  }
	}
      }

    } while (board[to] != 0);

    cout << from << "-" << to << endl;

  }
  return 0;
}

/// Local Variables:          ***
/// compile-command: "make"   ***
/// End:                      ***
