// pf/ui.hxx
// PF window.
//
// This file is part of the apsu project.
// See http://www.langbein.org/software/apsu/.
//
// Copyright (C) 2005 Frank C. Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// But WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.

#ifndef PF_UI
#define PF_UI 1

#include <gtkmm.h>

namespace PF {

  class Map;

  class PF::UI : public Gtk::Window {

  public:

    UI ();
    virtual ~UI ();

  private:

    class MapArea : public Gtk::DrawingArea {

    public:

      MapArea (PF::Map *map);
      virtual ~MapArea ();

    protected:

      virtual void on_realize ();
      virtual bool on_expose_event (GdkEventExpose* e);

      Glib::RefPtr<Gdk::GC> gc_;
      Gdk::Color ocean_;
      Gdk::Color mountain_;
      Gdk::Color forest_;
      Gdk::Color plane_;
      Gdk::Color path_;
      Gdk::Color solution_;

    private:
     
      Map *map_;

    };

    Map *map_;
    MapArea *map_area_;
  };

}

#endif // PF_UI
