// config-pf.c
// Apsu configuration header.
//
// This file is part of the apsu project.
// See http://www.langbein.org/software/apsu/.
//
// Copyright (C) 2004 Frank C. Langbein <frank@langbein.org>
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.
//
// $Id$

#ifndef CONFIG_APSU_H
#define CONFIG_APSU_H 1

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

#ifdef DEBUG

/* Set RCS id.
 *
 * Set the RCS id for the module. This defines a variable
 * rcsid_##module which points to the RCS id string. This way of
 * setting the string will avoid any Warnings about it and still
 * provide all the RCS id strings in the binary.
 */
#define ID(component, module, idstr) \
namespace component { \
  char const *rcsid_##module = idstr; \
}

#else // DEBUG

#define ID(component, module, idstr)

#endif// DEBUG

#ifdef __cplusplus
}
#endif // __cplusplus

#include <assert.h>

#endif /* CONFIG_APSU_H */
